#include "FLAME.h"

#define CC(i,j) buf_C[ (j)*(ldim_C) + (i) ]
#define EE(i,j) buf_E[ (j)*(ldim_E) + (i) ]

int FLA_SA_Pivot_unb( FLA_Obj C, FLA_Obj E, FLA_Obj p )
{
  int m_C, m_E, n_C, m_p, ldim_C, ldim_E, i;
  FLA_Datatype datatype;
  int *buf_p;

  m_C = FLA_Obj_length( C );
  n_C = FLA_Obj_width( C );
  m_E = FLA_Obj_length( E );
  m_p = FLA_Obj_length( p );

  ldim_C = FLA_Obj_ldim( C );
  ldim_E = FLA_Obj_ldim( E );

  datatype = FLA_Obj_datatype( C );
  
  buf_p = ( int * ) FLA_Obj_buffer( p );

  if ( datatype == FLA_DOUBLE ){
    double *buf_C, *buf_E;

    buf_C = ( double * ) FLA_Obj_buffer( C );
    buf_E = ( double * ) FLA_Obj_buffer( E );

    for ( i=0; i<m_p; i++ ){
      if ( buf_p[ i ] != 0 ) 
	FLA_C2F(dswap) ( &n_C, &CC( i, 0 ), &ldim_C, 
			 &EE( buf_p[ i ] - ( m_C - i ), 0 ), &ldim_E );
    }
  }
  else
    FLA_Abort( "Datatype not yet supported", __LINE__, __FILE__ );

  return FLA_SUCCESS;
}
